/* Fakiir
 *
 * (C) Copyright 2005 Denis Rojo <jaromil@dyne.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * "$Id: $"
 *
 */

#include <iostream>
#include <stdio.h>
#include <unistd.h>
#include <semantics.h>
#include <generator.h>

extern int yylex();
extern FILE *yyin;

extern Object_map *treesort();

int main(int argc, char **argv) {
	
	if( argc <2) {
		fprintf(stderr,"usage: fakiir header_file\n");
		exit(1);
	}
		
	yyin = fopen(argv[1],"r");

	yylex();

	Object_map *syms = treesort();

	fprintf(stderr,"tree of %i parents formed\n",syms->size());
	
	treegen( syms, argv[1] );

	exit(0);
}
 
