/// simple example program using a class object created by Fakiir

// this is not yet documented as it should, anyway it does just
// read the class structure and print it out.
// it can then fill in the argument values and call the exec() methods
// this is implemented in fakiir but not yet debugged


//#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>

#include <fakiir-models.h>
#include <readline/readline.h>

#include <testclass.h>

Pippo::Pippo() {
	yourname = NULL;
	position = 0;
}

Pippo::~Pippo() {
	if(yourname) free(yourname);
}

void Pippo::hello(char *name) {
	if(yourname) free(yourname);
	yourname = strdup(name);
	fprintf(stderr,"Hi %s, please to meet you.\n",yourname);
}

void Pippo::forward(int steps) {
	fprintf(stderr,"moving forward of %u steps\n",steps);
	position += steps;
}

void Pippo::backward(int steps) {
	fprintf(stderr,"moving backwards of %u steps\n",steps);
	position -= steps;
}

void Pippo::goodbye() {
	fprintf(stderr,"see you %s!\n",yourname);
}

extern void fakiir_init();
extern Object_map fakiir_symbols;

int main(int argc, char *argv) {
  Pippo pippo;

  Object_map::iterator o_iter;
  Object *o;

  Method_map::iterator m_iter;
  Method *m;

  Argument_map::iterator a_iter;
  Argument *a;
  
  fakiir_init();

  // initialize Pippo class
  o = fakiir_symbols["Pippo"];
  if(o) o->real = &pippo;


  ///////////////////////////////////////
  /// read the methods and print them out
  
  fprintf(stderr,"available methods:\n");


  
  for(o_iter = fakiir_symbols.begin(); o_iter != fakiir_symbols.end(); ++o_iter) {
    o = (*o_iter).second;



    for(m_iter = o->methods.begin(); m_iter != o->methods.end(); ++m_iter) {
      m = (*m_iter).second;


      
      // print out method name
      fprintf(stderr,"- %s (",m->name.c_str());


      
      // print out arguments
      for(a_iter = m->args.begin(); a_iter != m->args.end(); ++a_iter) {
	a = (*a_iter);


	fprintf(stderr,"%s %s  ",
		(a->type==INT_VALUE)?"integer":
		(a->type==FLOAT_VALUE)?"float":
		(a->type==STRING_VALUE)?"string":"unknown",
		a->name.c_str());
	
      }

      // go to the next method
      fprintf(stderr,")\n");

    }
    

  }

  // pick the only object
  o = (*fakiir_symbols.begin()).second;
  // the 'second' is there because it's a pair and we want the data part  
  
  /////////////////////////////////////////
  // ask for commandline input
  char *cmd;
  char tmp[254];

  while(1) {

    cmd = readline("your command> ");

    m = o->methods[cmd];
    if(m) {
      fprintf(stderr,"method %s found\n",m->name.c_str());

      for(a_iter = m->args.begin(); a_iter != m->args.end(); ++a_iter) {
	a = (*a_iter);

	sprintf(tmp,"%s %s> ",
		(a->type==INT_VALUE)?"integer":
		(a->type==FLOAT_VALUE)?"float":
		(a->type==STRING_VALUE)?"string":"unknown",
		a->name.c_str());

	cmd = readline(tmp);
	a->set(cmd);
      }
      m->exec();
		       
    } else fprintf(stderr,"unrecognized method \"%s\"\n",cmd);    
  }
  
  exit(1);
}
	
